/*
 *  $Id: comm_rank.c,v 1.5 1993/11/12 12:31:42 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */


#ifndef lint
static char vcid[] = "$Id: comm_rank.c,v 1.5 1993/11/12 12:31:42 doss Exp $";
#endif /* lint */

#include <mpi.h>

/*@

MPI_Comm_rank - determine the rank of the calling process in the communicator

@*/
int MPI_Comm_rank ( comm, rank )
MPI_Comm comm;
int *rank;
{
  if ( (comm != (MPI_Comm)0) && (comm->group != (MPI_Group)0) ) 
    (*rank) = comm->group->local_rank;
  else
    (*rank) = MPI_UNDEFINED;
  return (MPI_SUCCESS);
}
