/*
 *  $Id: finalize.c,v 1.4 1993/11/12 12:06:45 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include "mpi.h"
#include "mpisys.h"

/*@
   MPI_Finalize - Terminate MPI execution environment
@*/
int MPI_Finalize()
{
    /*  Dump final status of queues
    printf("Dumping send queue...\n");
    MPIR_dump_queue( &posted_sends );
    printf("Dumping recv queue...\n");
    MPIR_dump_queue( &posted_recvs );
    printf("Dumping unexpected queue...\n");
    MPIR_dump_queue( &unexpected_recvs );
    */

    /* Free allocated space */
    SBfree( MPIR_dtes, MPIR_int_dte );
    SBfree( MPIR_dtes, MPIR_float_dte );
    SBfree( MPIR_dtes, MPIR_double_dte );
    SBfree( MPIR_dtes, MPIR_long_dte );
    SBfree( MPIR_dtes, MPIR_short_dte );
    SBfree( MPIR_dtes, MPIR_char_dte );
    SBfree( MPIR_dtes, MPIR_byte_dte );
    SBfree( MPIR_dtes, MPIR_uchar_dte );
    SBfree( MPIR_dtes, MPIR_ushort_dte );
    SBfree( MPIR_dtes, MPIR_ulong_dte );
    SBfree( MPIR_dtes, MPIR_uint_dte );

    SBdestroy( MPIR_dtes );
    SBdestroy( MPIR_qels );
    SBdestroy( MPIR_fdtels );
    SBdestroy( MPIR_shandles );
    SBdestroy( MPIR_rhandles );

    SBdestroy( MPIR_hbts );
    SBdestroy( MPIR_hbt_els );

    MPIR_FreeGroup( MPI_COMM_WORLD->group );
    FREE( MPI_COMM_WORLD );

    /* Tell device that we are done */
    MPID_end();

    /* barrier */
    return MPI_OK;
}
