/*
 *  $Id: testany.c,v 1.7 1993/11/12 12:08:37 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include "mpi.h"
#include "mpisys.h"

/*@
    MPI_Testany - 
@*/
MPI_Testany( count, handles, index, status )
int        count;
MPI_Comm_request handles[];
int        *index;
MPI_Status *status;
{
    int i, found;

    found = 0;
    for (i = 0; i < count; i++)
    {
	if ( handles[i] != NULL )
	if ( handles[i]->type == MPIR_SEND )
	    if (handles[i]->shandle.completed == YES)
	    {
		found         = 1;
		*index        = i;
		MPID_complete_send( &handles[i]->shandle, status );
		MPI_Commreq_free( handles[i] ); /* Spec requires, but... */
		handles[i]    = NULL;
		break;
	    }
	else
	    if (handles[i]->rhandle.completed == YES)
	    {
		found         = 1;
		*index        = i;
		MPID_complete_recv( &handles[i]->rhandle );

		status->source = handles[i]->rhandle.source;
		status->tag    = handles[i]->rhandle.tag;
		status->count  = handles[i]->rhandle.actcount;

		MPI_Commreq_free( handles[i] ); /* Spec requires, but... */
		handles[i]    = NULL;
		break;
	    }
    }
    if ( !found )
	*index = -1;
}
